#include "stdafx.h"
#include "Graphic.h"

#define defWindowTitle _T("_VF[_Tv")
#define defWindowClass _T("sampleapp")

//_̒`
#define D3DFVF_VERTEX ( D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1 )
struct CUSTOMVERTEX
{
	D3DVECTOR	pos;	//_̈ʒu
	DWORD		color;	//_̐F
	float		tu;		//eNX`W
	float		tv;
};

//|S
class Plane
{
	float w;
	float h;
	
	IDirect3DVertexBuffer9* m_pVB;			//|S̃obt@

public:
	Plane(){ m_pVB = NULL;}

	~Plane()
	{
		Release();
	}
	void Release()
	{
		if ( m_pVB ) {
			m_pVB->Release();
			m_pVB = NULL;
		}
	}
	void Create( float w, float h, DWORD color )
	{
		GetDevice()->CreateVertexBuffer( sizeof(CUSTOMVERTEX)*12, 0, D3DFVF_VERTEX, D3DPOOL_MANAGED, &m_pVB, NULL );
		
		float half_w = w * 0.5f;
		float half_h = h * 0.5f;

		CUSTOMVERTEX *d3dv;
		m_pVB->Lock(0 , 0 , (void**)&d3dv , 0);
		d3dv[0].pos.x = -half_w;
		d3dv[0].pos.y = half_h;
		d3dv[0].pos.z = 0;
		d3dv[0].color = color;
		d3dv[0].tu = 0;
		d3dv[0].tv = 0;

		d3dv[1] = d3dv[0];
		d3dv[1].pos.x = half_w;
		d3dv[1].pos.y = -half_h;
		d3dv[1].tu = 1.0f;
		d3dv[1].tv = 1.0f;

		d3dv[2] = d3dv[0];
		d3dv[2].pos.x = -half_w;
		d3dv[2].pos.y = -half_h;
		d3dv[2].tu = 0.0f;
		d3dv[2].tv = 1.0f;

		d3dv[3] = d3dv[0];

		d3dv[4] = d3dv[0];
		d3dv[4].pos.x = half_w;
		d3dv[4].pos.y = half_h;
		d3dv[4].tu = 1.0f;
		d3dv[4].tv = 0;

		d3dv[5] = d3dv[1];
		
		//
		d3dv[6] = d3dv[4];
		d3dv[7] = d3dv[2];
		d3dv[8] = d3dv[1];
		d3dv[9] = d3dv[4];
		d3dv[10] = d3dv[0];
		d3dv[11] = d3dv[2];

		m_pVB->Unlock();
	}
	
	void Render()
	{
		GetDevice()->SetStreamSource( 0, m_pVB, 0, sizeof(CUSTOMVERTEX) );
		GetDevice()->DrawPrimitive( D3DPT_TRIANGLELIST, 0, 4);
	}
};

//Av{
class MyApp
{
	LPDIRECT3DTEXTURE9 m_texture;
	Plane	m_plane;

	//_VF[_
	VertexShader	m_shader;

	D3DXMATRIX m_matView;//r[s
	D3DXMATRIX m_matProj;//vWFNVs

public:
	//TvAv̏
	void Init(HWND hWnd)
	{
		//DirectX
		LGraphic_Create( hWnd );

		//eNX`̃[h
		m_texture = LGraphic_LoadTexture( _T(".\\image\\sample.jpg") );

		//̍쐬
		m_plane.Create( 4, 3, 0xFFFFAAAA );

		//_VF[_̃[h
		m_shader.Create(_T(".\\shader\\sample.txt"));

		//r[
		D3DXMatrixLookAtRH( &m_matView, &D3DXVECTOR3( 0.0f, 0.0f, 5.0f ), &D3DXVECTOR3( 0.0f, 0.0f, 0.0f ), &D3DXVECTOR3( 0.0f, 1.0f, 0.0f ) );
		//vWFNV
		D3DXMatrixPerspectiveFovRH( &m_matProj, D3DXToRadian(60.0f), (float)(640.0f/480.0f), 0.1f, 10000.0f );
	}

	void Roop()
	{
		//_VF[_̃Zbg
		m_shader.Attuch();	//ł`̂тɌĂԕKv͂ȂłixZbg\j

		LGraphic_ClearAndBegin();
		
		LGraphic_SetTexture(m_texture);
		
		//_VF[_ɓnp[^Zbg
		{
			D3DXMATRIX mat_rot;
			static float roty = 0.1f;
			roty += 0.1f;
			if ( roty > ( 3.14f*2.0f ) ){
				roty -= ( 3.14f*2.0f );
			}
			D3DXMatrixRotationY( &mat_rot, roty );
			
			//WϊsZbg
			D3DXMATRIX mat;
			mat = mat_rot;
			mat *= m_matView;
			mat *= m_matProj;
			D3DXMatrixTranspose( &mat, &mat );//]us쐬
			GetDevice()->SetVertexShaderConstantF( 0, ( float* )&mat, 4 );
			
		}
		
		//̕`
		m_plane.Render();

		LGraphic_EndAndPresent();
	}

	//TvAv̉
	void Release()
	{
		//eNX`̉
		if(m_texture) {
			m_texture->Release();
			m_texture = NULL;
		}
		m_plane.Release();

		//_VF[_
		m_shader.Release();

		//DirectX̉
		LGraphic_Release();
	}

};
static MyApp myApp;

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_PAINT:
		//WM_PAINTł͕`悵܂B
		//ValidateRectgƎWM_PAINTĂ΂ȂȂBitXN[\̎j
		ValidateRect( hWnd, NULL );
		break;
	case WM_DESTROY:
		myApp.Release();//TvAv
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	MSG msg;
	
	//EBhENX̓o^
	WNDCLASSEX wcex;
	memset( &wcex, 0, sizeof(wcex) );
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= defWindowClass;

	if( !RegisterClassEx(&wcex) ) {
		return FALSE;
	}

	HWND hWnd;
	hWnd = CreateWindow( defWindowClass, defWindowTitle, WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
	CW_USEDEFAULT, 0, 640, 480, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{
		return FALSE;
	}
	
	//TvAv̏
	myApp.Init(hWnd);

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	for (;;) {
		if ( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ) {
			
			if ( GetMessage( &msg, NULL, 0, 0 ) > 0) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			} else {
				break;
			}

		} else {
			//Q[̏ł
			myApp.Roop();
		}
	}

	return (int) msg.wParam;
}
