#include "stdafx.h"
#include "Graphic.h"

VertexShader::VertexShader()
{
	m_pShader = NULL;
	m_pVertexDeclaration = NULL;
}

//_VF[_쐬iAZut@C̓ǂݍ݁j
bool VertexShader::Create( LPCWSTR path )
{
	if ( m_pShader || m_pVertexDeclaration ) {
		Release();
	}
	
	try {

		HRESULT hr;

		D3DCAPS9 caps;
		GetDevice()->GetDeviceCaps(&caps);
		
		//_VF[_g邩
		if ( caps.VertexShaderVersion < D3DVS_VERSION(1,1) ) {
			::MessageBox(NULL,_T("p̃OtBbNX{[h͒_VF[_ɑΉĂ܂B"),_T(""),MB_OK);
			throw 0;
		}

		//pCvCɓn_f[^̍\`
		//CUSTOMVERTEXɏ]č쐬
		D3DVERTEXELEMENT9 decl[] = {
			{ 0, 0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },	//ʒu
			{ 0, 12, D3DDECLTYPE_D3DCOLOR, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR, 0},	//F
			{ 0, 16, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0},	//eNX`W
			D3DDECL_END() //ŌɕKD3DDECL_END()
		};

		hr = GetDevice()->CreateVertexDeclaration( decl, &m_pVertexDeclaration );
		if ( FAILED( hr) ) {
			throw 0;
		}

		//\[X̓ǂݍ
		LPD3DXBUFFER pShaderSource;
		LPD3DXBUFFER pErrMessage = NULL;
		hr = D3DXAssembleShaderFromFile( path, NULL, NULL, 0, &pShaderSource, &pErrMessage );
		if ( FAILED(hr) ) {
			//G[bZ[W̕R[hANSI
			::MessageBoxA(NULL,(LPCSTR)(pErrMessage->GetBufferPointer()),"",MB_OK);
			pErrMessage->Release();
			throw 0;
		}
		
		//_VF[_쐬
		hr = GetDevice()->CreateVertexShader( ( DWORD* )pShaderSource->GetBufferPointer(), &m_pShader );
		if ( FAILED(hr) ) {
			throw 0;
		}

		//_VF[_\[X͉ėǂ
		pShaderSource->Release();

	} catch(...)
	{
		Release();
		return false;
	}

	return true;
}

//_VF[_Kp
void VertexShader::Attuch()
{
	GetDevice()->SetVertexShader(m_pShader);
	GetDevice()->SetVertexDeclaration(m_pVertexDeclaration);
}

//_VF[_
void VertexShader::Release()
{
	if ( m_pShader ) { m_pShader->Release(); }
	if ( m_pVertexDeclaration ) { m_pVertexDeclaration->Release(); }
}